package Ghostbuster
{
	function fxDTSBrick::onAdd(%brick)
	{
		Parent::onAdd(%brick);
		if($Ghostbusters::Called)
		{
			if(!%brick.isPlanted)
			{
				schedule(10,0,"GBCheck",%brick);
			}
		}
	}
	function servercmdplantbrick(%c)
	{
		Parent::servercmdplantbrick(%c);
		if($Ghostbusters::Called)
		{
			cancel(%c.GBSched);
			%c.GBSched = schedule($Ghostbusters::Delay*1000,%c,"servercmdcancelbrick",%c);
		}
	}
	function servercmdshiftbrick(%c,%sx,%sy,%sz)
	{
		Parent::servercmdshiftbrick(%c,%sx,%sy,%sz);
		if($Ghostbusters::Called)
		{
			cancel(%c.GBSched);
			%c.GBSched = schedule($Ghostbusters::Delay*1000,%c,"servercmdcancelbrick",%c);
		}
	}
	function servercmdcancelbrick(%c)
	{
		Parent::servercmdcancelbrick(%c);
		if($Ghostbusters::Called)
		{
			cancel(%c.GBSched);
		}
	}
	function onExit()
	{
		export("$Ghostbusters::*","config/server/GBPrefs.cs");
		Parent::onExit();
	}
	function servercmduseinventory(%c,%slot)
	{
		Parent::servercmduseinventory(%c,%slot);
		if(%slot != %c.invSlot)
		{
			%c.invSlot = %slot;
			if(isObject(%c.player.tempbrick))
			{
				if($Ghostbusters::Called)
				{
					cancel(%c.GBSched);
					%c.GBSched = schedule($Ghostbusters::Delay*1000,%c,"servercmdcancelbrick",%c);
				}
			}
		}
	}
};
ActivatePackage(Ghostbuster);
function GBCheck(%brick)
{
	if(!$Ghostbusters::Called)
	{
		return;
	}
	if(!%brick.isPlanted)
	{
		%c = getbrickgroupfromobject(%brick).client;
		cancel(%c.GBSched);
		%c.GBSched = schedule($Ghostbusters::Delay*1000,%c,"servercmdcancelbrick",%c);
	}
}
function servercmdclearallghosts(%c)
{
	if(%c.isAdmin)
	{
		for(%i=0;%i<ClientGroup.getCount();%i++)
		{
			servercmdcancelbrick(ClientGroup.getObject(%i));
		}
		messageall('',"\c3" @ %c.name SPC "\c2busted all ghosts.");
	} else {
		messageclient(%c,'',"\c2You need to an \c3Admin\c2 to use the \c3/clearallghosts\c2 command.");
	}
}
function GBINIT()
{
	if(!$GBT_RanPrefs)
	{
		$Ghostbusters::Called = 1;
		$Ghostbusters::Delay = 30;
		if(isFile("config/server/GBPrefs.cs"))
		{
			exec("config/server/GBPrefs.cs");
		}
		$GBT_RanPrefs = 1;
	}
	if(isFile("add-ons/System_ReturnToBlockland/server.cs"))
	{
		if(!$RTB::RTBS_ServerControl)
		{
			exec("add-ons/system_ReturnToBlockland/RTBR_ServerControl_Hook.cs");
		}
		if(!$GBT_AddedPrefs)
		{
			RTB_registerPref("Called","Ghostbuster","$Ghostbusters::Called","bool","Ghostbuster",$Ghostbusters::Called,false,false);
			RTB_registerPref("Delay","Ghostbuster","$Ghostbusters::Delay","int 10 60","Ghostbuster",$Ghostbusters::Delay,false,false);
			$GBT_AddedPrefs = 1;
		}
	}
}
schedule(25,0,"GBINIT");